angular.module('starter.controllers')

.controller('agreeCtrl', function($rootScope, $scope, $state, $stateParams, $window, $ionicHistory, $ionicLoading, $filter, $timeout, $ionicPopup, service_agree, service_timelabel, service_gmap, service_mcache, _SERVER_SETTINGS ){

    var agree = {};

    agree.agree_id = $stateParams.agree_id;

    agree.cdn = _SERVER_SETTINGS.image_cdn_url;

    agree.data = {};

    agree.timeago = service_timelabel.timeago;

     

    agree.get = function(){
        service_agree.get(agree.agree_id)
        .then(function(res){
             //console.warn("resss AGRE"+JSON.stringify(res));
             if(res.error == 0)
             {
                 res.data.agree.distance_km = service_gmap.distance(service_mcache.get('_CURRENT_LOCATION')||{lat: res.data.agree.latitude, lng: res.data.agree.longitude},{lat: res.data.agree.latitude, lng: res.data.agree.longitude});

                 res.data.agree.distance_text = $filter('translate')('AboutXkmAway').replace('XX',res.data.agree.distance_km);
                 agree.data = res.data.agree;
                 delete res;
                 //console.log("res.data",JSON.stringify(res.data))
             }
             else
             {
                 // user agree si bulunamadı
             }
        },function(){

        })
    };

    agree.start_chat = function(user_id){

        //alert("mesajlaşma açılacak "+user_id);
    };
    
    $scope.$on("$ionicView.enter",function(){
        $timeout(function(){
        agree.get();
        });
    });

    $scope.agree = agree;
});