angular.module('starter.controllers')

.controller('messageStartCtrl', function($rootScope, $scope, $state, $stateParams, $window, $ionicHistory, $ionicLoading, $ionicPopup, $timeout, $filter, service_message, _SERVER_SETTINGS){

	 var chat = {};

     chat.target_user_id = $stateParams.targer_user_id;
     chat.target_user = {};

     chat.cdn = _SERVER_SETTINGS.image_cdn_url;

     chat.message = '';

     

     chat.get_target = function(){
        $ionicLoading.show();
        if(chat.target_user_id)
        {
            service_message.get_target( chat.target_user_id)
            .then(function(res){
                $ionicLoading.hide();
                //console.warn("GET_TARGET",JSON.stringify(res))
                if(res.error == 0)
                {
                    if(res.data.can_chat == true)
                    {
                        chat.target_user = res.data.target_user;
                        chat.agreed_text = $filter('translate')('AgreedStartChat').replace('XX',chat.target_user.name);
                    }
                    else
                    {
                        chat.not_auth();
                    }
                }
                else
                chat.not_auth();
            },function(){
                    $ionicLoading.hide();
                chat.not_auth();
            }) 
        }
        else
        {
            chat.not_auth();
        }
     };
 
     chat.not_auth = function(){
          var alertPopup = $ionicPopup.alert({
                title: $filter('translate')('Error'),
                template: $filter('translate')('NoUserToStartChat'),
                cssClass: 'text-center',
                okType: 'button-calm'
            });

            alertPopup.then(function(res) {
                 $ionicHistory.goBack() || $state.go("app.search");
            });
     }



     chat.send_message = function(){
        if(chat.message.replace(/\s/g,'' ).length > 0 )
        {
            service_message.send_message(chat.target_user_id, chat.message)
            .then(function(res){
                if(res.error == 0)
                {
                    chat.done();
                }
                else
                {
                    if(res.message == 'daily_free_limit_exceeded')
                    {
                        var alertPopup = $ionicPopup.alert({
                                title: $filter('translate')('Error'),
                                template: $filter('translate')('daily_message_limit_reached'),
                                okType: 'button-calm',
                                cssClass: 'text-center bigPopup'
                            });

                            alertPopup.then(function(res) {
                                $state.go("app.vip");
                            });
                    }
                }

            },function(){
                chat.not_auth();
            })
        }
        else
        {
            chat.message = '';
        }
     };
    
    chat.done = function(){
        var confirmPopup = $ionicPopup.confirm({
            title: $filter('translate')('MessageSentSuccess'),
            template: $filter('translate')('MessageSentSuccessText'),
            cssClass:'text-center',
            okType: 'button-calm',
            okText: $filter('translate')('GoSeeOthers'),
            cancelText: $filter('translate')('GoMessages')
        });

        confirmPopup.then(function(res) {
            if(res) {
             $ionicHistory.goBack(-2);
            } else {
                $state.go("app.messages");
            }
        });
    }


     $scope.chat = chat;

     $scope.$on("$ionicView.enter",function(){
        $timeout(function(){
            chat.get_target();
        });
     });

        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.messages");
        };
      
});