angular.module('starter.services')
.factory('service_gmap', function($q, $ionicPlatform, $window, $http, $translate, service_api ,service_user, _APP_SETTINGS,_SERVER_SETTINGS){
		// dkmantasyon https://developers.google.com/maps/documentation/static-maps/intro ve https://developers.google.com/maps/documentation/javascript/reference#MapTypeStyleFeatureType
	var map = {};

	map.key = _SERVER_SETTINGS.google_maps_api_key;//"AIzaSyBc3ewllYqaEdixazJhklFddQxIjtu6S14";
	map.base_uri = "http://maps.googleapis.com/maps/api/staticmap?key="+map.key;
	
	map.size = "320x200" ;
	map.scale = "2" ;
	
	map.center = "turkey" ; // lat lon veya adres
	map.zoom = "14" ;
	map.path = "" ;
	
	map.format ="png";
	map.maptype ="terrain"; // roadmap , terrain satellite hybrid
	
	map.language = ""; // bo kalrsa hangi yerse onun dilinde gsterir
	map.region  = ""; // siyasi harita snrlar, 2 haneli ulke kodu
	
	map.style = [
					'feature:road.local|element:geometry|color:0xc18f1f|visibility:on', // yollar, 
					'feature:road.highway|element:geometry|color:0x864703|weight:1|visibility:on', // yollar, 
					'feature:road.arterial|element:geometry|color:0x7c5f3c|weight:1|visibility:on', // yollar, 
					
					'feature:all|element:labels|color:0xfff8c0|visibility:simplified', //isimleri en aza indirger, isimler etiketler , visibilty on off simplified, 
					'feature:all|element:labels.icon|visibility:off', // tm yerlerdeki isim ikonlarn kaldrr, isimler etiketler , visibilty on off simplified, 
					
					'feature:landscape|element:geometry|color:0xdad5bf|visibility:on', 	// yerlerin rengi
					'feature:water|element:all|color:0xacb2ff|visibility:on' // suyun rengi
					
					//'feature:landscape.man_made|element:geometry.fill|color:0xeeeeee|visibility:on' 	// yerler
					//'feature:landscape.natural|element:geometry.fill|color:0xeeeeee|visibility:on' 	// yerler
					//'feature:road|element:labels.icon|visibility:off', // yollardaki isim ikonlarn kaldrr, isimler etiketler , visibilty on off simplified, 
					//'feature:poi|element:labels.icon|visibility:off', // isimler etiketler , visibilty on off simplified, 
					//http://maps.googleapis.com/maps/api/staticmap?key=AIzaSyBc3ewllYqaEdixazJhklFddQxIjtu6S14&size=640x400&zoom=15&scale=2&center=turkey istanbul ili kocamansur sokak&maptype=terrain&style=feature:road.local|element:geometry|color:0xc18f1f|visibility:on&style=feature:road.highway|element:geometry|color:0x864703|weight:1|visibility:on&style=feature:road.arterial|element:geometry|color:0x7c5f3c|weight:1|visibility:on&style=feature:all|element:labels|color:0xffffff|visibility:simplified&style=feature:all|element:labels.icon|visibility:off&style=feature:landscape|element:geometry|color:0xdad5bf|visibility:on&style=feature:water|element:all|color:0xacb2ff

				];
	
	map.final_uri = "";
	
	
	/*map bounds*/
	var MERCATOR_RANGE = 256;

	function bound(value, opt_min, opt_max) {
	  if (opt_min != null) value = Math.max(value, opt_min);
	  if (opt_max != null) value = Math.min(value, opt_max);
	  return value;
	}

	function degreesToRadians(deg) {
	  return deg * (Math.PI / 180);
	}

	function radiansToDegrees(rad) {
	  return rad / (Math.PI / 180);
	}

	function MercatorProjection() {
	  this.pixelOrigin_ = {x: MERCATOR_RANGE / 2, y: MERCATOR_RANGE / 2};
	  this.pixelsPerLonDegree_ = MERCATOR_RANGE / 360;
	  this.pixelsPerLonRadian_ = MERCATOR_RANGE / (2 * Math.PI);
	};

	MercatorProjection.prototype.fromLatLngToPoint = function(latLng, opt_point) {
	  var me = this;

	  var point = opt_point || {x:0, y:0};

	  var origin = me.pixelOrigin_;
	  point.x = origin.x + latLng.lng * me.pixelsPerLonDegree_;
	  // NOTE(appleton): Truncating to 0.9999 effectively limits latitude to
	  // 89.189.  This is about a third of a tile past the edge of the world tile.
	  var siny = bound(Math.sin(degreesToRadians(latLng.lat)), -1, 1);
	  point.y = origin.y + 0.5 * Math.log((1 + siny) / (1 - siny)) * -me.pixelsPerLonRadian_;
	  return point;
	};

	MercatorProjection.prototype.fromPointToLatLng = function(point) {
	  var me = this;

	  var origin = me.pixelOrigin_;
	  var lng = (point.x - origin.x) / me.pixelsPerLonDegree_;
	  var latRadians = (point.y - origin.y) / -me.pixelsPerLonRadian_;
	  var lat = radiansToDegrees(2 * Math.atan(Math.exp(latRadians)) - Math.PI / 2);
	  return {lat:lat, lng:lng};
	};
	/*map bounds*/
	
	var lang_code = $translate.use();
	// geocode
	var geocode = {};
	geocode.key = key = _SERVER_SETTINGS.google_maps_api_key;
	geocode.base_uri = "https://maps.googleapis.com/maps/api/geocode/json?key="+geocode.key+"&language="+lang_code+"&latlng=#LAT#,#LONG#";
	geocode.base_uri_address = "https://maps.googleapis.com/maps/api/geocode/json?key="+geocode.key+"&language="+lang_code+"&address=#ADDRESS#";
	// https://maps.googleapis.com/maps/api/geocode/json?key=AIzaSyBc3ewllYqaEdixazJhklFddQxIjtu6S14&latlng=41.0630937,28.9869518
	
	var rad = function(x) {
	  return x * Math.PI / 180;
	};
  
  //user
                
		 return {
				distance: function(p1, p2)
				{
					//console.log(JSON.stringify(p1));
					//console.log(JSON.stringify(p2));
				  var R = 6378137; // Earths mean radius in meter
				  var dLat = rad(p2.lat - p1.lat);
				  var dLong = rad(p2.lng - p1.lng);
				  var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
					Math.cos(rad(p1.lat)) * Math.cos(rad(p2.lat)) *
					Math.sin(dLong / 2) * Math.sin(dLong / 2);
				  var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
				  var d = R * c;
				  var res =  Math.round(d); // returns the distance in meter
				  if(res > 1000)
				  return  Math.floor((res/1000)*10)/10+"km";
				  else
				  return res +"m";
				},
				set: function(options)
					 {
						//console.log(options);
						for(var propertyName in options) {
						  // console.log(propertyName);
						  // console.log(options[propertyName]);
						   map[propertyName] = options[propertyName];
						   
						   return true;
						}
						
					 },
				 get: function(key)
					  {
						return map[key];
					  },
					  
			  init: function()
					  {
						if(map.final_uri != "")
						{
							map.final_uri = "";
						}
							map.final_uri += map.base_uri;
							var query_string = "";
							for(var pname in map)
							{
								if(map[pname] != '' && pname != "base_uri" && pname != "key" && pname != 'final_uri')
								{
									if(Object.prototype.toString.call( map[pname] ) === '[object Array]')
									{
										//console.log(map[pname]);
										for(var i in map[pname])
										{
											query_string += '&'+pname+"="+encodeURIComponent(map[pname][i]);
										}
									}
									else
									{
										query_string += '&'+pname+"="+encodeURIComponent(map[pname]);
									}
								}
							}
							//console.log(map.final_uri);
							return map.final_uri+query_string;
					  },
				width : function(){
							
							var dim = map.size.split("x");
							return map.scale*dim[0];
						},
				height : function(){
							
							var dim = map.size.split("x");
							return map.scale*dim[1];
						},
						
				// geocode
				getAddressViaLatLong: function(lat,long){
				
					if(lat && long)
					{
						var uri = geocode.base_uri.replace("#LAT#",lat).replace("#LONG#",long);
						return $http.get(uri);
					}
					return false;
				},
				getLatLngViaAddress: function(address){
				
					if(address)
					{
						var uri = geocode.base_uri_address.replace("#ADDRESS#",address);
						return $http.get(uri);
					}
					return false;
				},
				parseAddressComponents: function(res){
					if(typeof res.data.results[0].address_components != "undefined")
					{
						return {formatted_address: res.data.results[0].formatted_address, lat: res.data.results[0].geometry.location.lat, lng: res.data.results[0].geometry.location.lng, full: res.data.results[0] }
					}
					
					return false;
				},
				getAddress: function(coords)
				{
					var defer = $q.defer();
					
					var lat = coords.split(",")[0], lng = coords.split(",")[1];
					var uri = geocode.base_uri.replace("#LAT#",lat).replace("#LONG#",lng);
					$http.get(uri).then(function(res){
						
						if(typeof res.data.results[0].address_components != "undefined")
						{
							var address_components = res.data.results[0].address_components, address_info = {};
							for( var i in address_components)
							{
								 
								if(address_components[i].types.indexOf('country') > -1)
								{
									address_info.country = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
									 
								}
								
								if( address_components[i].types.indexOf('administrative_area_level_1') > -1)
								{
									address_info.level1 = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
								}
								if( address_components[i].types.indexOf('administrative_area_level_2') > -1)
								{
									address_info.level2 = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
								}
								if( address_components[i].types.indexOf('administrative_area_level_3') > -1)
								{
									address_info.level3 = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
								}
								if( address_components[i].types.indexOf('administrative_area_level_4') > -1)
								{
									address_info.level4 = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
								}
								 
								if( address_components[i].types.indexOf('administrative_area_level_5') > -1)
								{
									address_info.level5 = {short_name:address_components[i].short_name,long_name:address_components[i].long_name}
								}
								 
							}
						
							
							var add =   (address_info.level4 ? address_info.level4.long_name +", ": '') + (address_info.level3 ? address_info.level3.long_name + ", " : '') + (address_info.level2 ? address_info.level2.long_name  : '');
							
							defer.resolve(add);
						}
						else
						defer.resolve(lat+","+lng);
					
					},function(){
					
						defer.resolve(lat+","+lng);
					});
					
					return defer.promise;
				},
				
				getMapBounds : function(lat,lng,zoom,mapWidth,mapHeight){
					/**/
					if(!mapWidth) mapWidth = 640; mapWidth = parseInt(mapWidth);
					if(!mapHeight) mapHeight = 640; mapHeight = parseInt(mapHeight);
					if(!zoom) zoom = 14; zoom = parseInt(zoom);
					if(!lat || !lng) return false;
					lat = parseFloat(lat);
					lng = parseFloat(lng);
					
					var proj = new MercatorProjection();
					var result = {n:0,e:0,s:0,w:0};					 
					var scale = Math.pow(2,zoom);
					var centerPx = proj.fromLatLngToPoint({lat:lat,lng:lng});
					var SWPoint = {x: (centerPx.x -(mapWidth/2)/ scale) , y: (centerPx.y + (mapHeight/2)/ scale)};
					var SWLatLon = proj.fromPointToLatLng(SWPoint);
					result.s =SWLatLon.lat;
					result.w =SWLatLon.lng;
					var NEPoint = {x: (centerPx.x +(mapWidth/2)/ scale) , y: (centerPx.y - (mapHeight/2)/ scale)};
					var NELatLon = proj.fromPointToLatLng(NEPoint);
					result.n =NELatLon.lat;
					result.e =NELatLon.lng;
					 

					
					return result;
					/**/
				},
				setCurLocation: function(center){
					     
					var defer = $q.defer();
					
					service_api.get("app.user.update",{},true)
					.then(function(){
					},function(){
					
					});
					
					
					return defer.promise;
				},
				getNeightbours: function(center,zoom,size){
					 //console.warn("\n\n\n center center "+JSON.stringify(center));
					    
					var defer = $q.defer();
					 
					
					return defer.promise;
				},
				mapNeighbours: function(user_list,map_bounds,map_options,direction_steps){
				
					var user_id = service_user.getUserId();
					var map_size = {w: parseInt(map_options.size.split("x")[0])*map_options.scale, h: parseInt(map_options.size.split("x")[1])*map_options.scale};

					var total_width_degree =   Math.abs( map_bounds.e - map_bounds.w); 
					var total_height_degree =  Math.abs( map_bounds.n - map_bounds.s); 
					
					var x_degree_2_pixel_value = ( map_size.w / total_width_degree); // X ekseninde 1 pixelin ka derece olduu
				    var y_degree_2_pixel_value = ( map_size.h / total_height_degree); // Y ekseninde 1 pixelin ka derece olduu
					
					var step_to_pixel_ns = _APP_SETTINGS.map_step_size * x_degree_2_pixel_value;
					var step_to_pixel_ew = _APP_SETTINGS.map_step_size * y_degree_2_pixel_value;
				   
				  //  console.warn("\n\nmap_bounds",JSON.stringify(map_bounds));  
				   
					 
					for(var id in user_list)
					{
						//console.log("Math.abs(map_bounds.n - user_list[id].latitude)",Math.abs(map_bounds.n - user_list[id].latitude));
						//console.log("Math.abs(map_bounds.w - user_list[id].longitude)",Math.abs(map_bounds.w - user_list[id].longitude));
						
						var posy = Math.abs( map_bounds.n - user_list[id].latitude  ) * y_degree_2_pixel_value;
						var posx = Math.abs( map_bounds.w - user_list[id].longitude ) * x_degree_2_pixel_value;
						
						//console.warn("\n\nposition",JSON.stringify({x: posx  ,y: posy}));
						user_list[id].position = {x: posx ,y: posy };
						user_list[id].type = user_id == id ? 'me' : 'enemy'; // buraya friend de koymak lazm
						//console.warn("\n\nuser_list["+id+"].position "+JSON.stringify(user_list[id].position));
					}
					
					return user_list;
				},
				
				shorten_coords: function(coords)
				{
					return Math.floor(coords.split(",")[0]*1000)/1000 + ","+Math.floor(coords.split(",")[1]*1000)/1000;
				}
					
				
			  }; 
      
        
});