/* by ertan 14:33 12.04.2016*/
'use strict';
angular.module('starter.services')
.factory('service_mcache', ['$q','service_localstorage','_APP_SETTINGS',function ($q,localstorage,_APP_SETTINGS) {
 
   
   var 	cache_name = 'theAppSpecCache.',
		max_age = _APP_SETTINGS.cache_max_age;
    
    var cache = {
		get :  function(key){
								//console.log("mcache get called: "+cache_name+key);
								var cache = localstorage.getObject(cache_name+key,false);
								if(cache)
								{
									//console.log("mcache.getcache "+JSON.stringify(cache));
									if(cache.lsCacheTimeout < new Date().getTime()/1000)
									{ 
										localstorage.remove(cache_name+key);
										return false;
									}
									else
									return cache.data;
								}
								return false;
							},
			 
		set :  function(key,val,timeout){
								//console.log("mcache set called: "+cache_name+key);
								var c = {};
								c.data = val;
								if(!timeout) timeout = max_age;
								c.lsCacheTimeout = timeout + Math.floor(new Date().getTime()/1000);
								localstorage.setObject(cache_name+key,c);
								
								return true;
							},
		remove : function(key)
						{
							localstorage.remove(cache_name+key);
							//console.log("mcache remove called: "+cache_name+key);
							return true;
						},
		removeAll : function(search)
						{
							var all = localstorage.getAll(cache_name+search+"*");
							//console.log("mcache removeAll called: "+cache_name+search);
							for(var i in all)
							{
								cache.remove(all[i]);
							}
							return true;
						} 
	};
    return  cache;
 
}]);