angular.module('starter.services')

.factory('service_message',  function($q, $timeout, $window, $cordovaGeolocation, $ionicPlatform, $ionicPopup, $filter, service_api, service_mcache, service_user)
{

    var message = {};

    message.get_block = function(target_user_id){

        
        var defer = $q.defer();

        service_api.get("app.messages.get_block",{target_user_id:target_user_id},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;

    };
    message.toggle_block = function(target_user_id){

        
        var defer = $q.defer();

        service_api.get("app.messages.toggle_block",{target_user_id:target_user_id},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;

    };
    message.send_seen = function(cid,target_user_id, message_id){
        var defer = $q.defer();

        service_api.get("app.messages.send_seen",{cid:cid, target_user_id:target_user_id, message_id:message_id},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;
    }

    message.get_messages = function(cid,page){
        var defer = $q.defer();

        service_api.get("app.messages.get_messages",{cid:cid, page:page},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;
    }

    message.get_conversations = function(page){
        var defer = $q.defer();

        service_api.get("app.messages.get_conversations",{page:page},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;
    }

    message.send_message = function(target_user_id, message){

        var defer = $q.defer();

        service_api.get("app.messages.send_message",{target_user_id:target_user_id, message:message},true)
        .then(function(res){
            defer.resolve(res);
        },function(){
            defer.reject();
        })

        return defer.promise;
    };

    

    message.get_target = function(target_user_id)
    {
        var defer = $q.defer();

        service_api.get("app.messages.get_target",{target_user_id: target_user_id},true)
        .then(function(res){

            defer.resolve(res);

        },function(){
            defer.reject();
        })

        return defer.promise;
    };


    return message;
	
});