angular.module('starter.services')
.factory('service_nativeaudio', function($q,$window, $timeout, $ionicPlatform){
  
	
    var audio = {};

    audio.preload = function(){
        audio.load("new_message",'sound/message.wav');
    }

    
     
    audio.load = function(id, src){
        var defer = $q.defer();

        $window.plugins.NativeAudio.preloadSimple( id, src, function(msg){
            console.log("NativeAudio",msg)
            defer.resolve(msg);
            // alert(msg)
        }, function(msg){
            console.log("NativeAudio err",msg)
           // alert(msg)
            defer.reject(msg);
        });

        return  defer.promise;
    }

    audio.new_message = function(is_play){
        if(is_play)
        $window.plugins.NativeAudio.play( "new_message" );
        else
        $window.plugins.NativeAudio.stop( "new_message" );
    }

    audio.unload = function(id){
        $window.plugins.NativeAudio.unload( id );
    }
    
    $ionicPlatform.ready(function(){
        $timeout(function(){
            audio.preload();
        },2000)
    })

	return audio;
});