angular.module('starter.services')
.factory('service_temp', function($q, _SERVER_SETTINGS){
  
	var temp = {};
	
	temp.data = {};
	
	temp.add = function(key,val,autodelete)
	{
		if(!autodelete) autodelete = false;
		if(!temp.data[key]) temp.data[key] = [];
		if(temp.data[key].length > 0)
		{
			for(var i = 0; i < 1; i++)
			{
				temp.data[key].splice(i,1);
			}
		}
		temp.data[key].push({val: val, autodelete: autodelete});
	};
	temp.set = temp.add;
	
	temp.get= function(key,index)
	{
		//console.warn(JSON.stringify(temp.data));
		if(temp.data[key])
		{
			var curr = temp.data[key][index];
			if(curr)
			{
				var the_val = curr.val;
				if(curr.autodelete == true)
				{
					temp.data[key].splice(index,1);
				}
				return the_val;
			}
		}
		return false;
	}

	temp.max_preloaded_depot = 20;
    temp.preloaded_gifs_data = [];
	temp.preloaded_gifs = [];
	temp.preload_gif = function(image_id){
		if(temp.preloaded_gifs.indexOf(image_id) == -1)
		{
			var src = _SERVER_SETTINGS.image_cdn_url+'w480h480/'+image_id;
			var img = new Image();
			img.onload = function(){
				temp.preloaded_gifs.push(image_id);
			}
			img.onerror = function(){
				img = null;
			};
			img.src = src;
			temp.preloaded_gifs_data.push(img);
			if(temp.preloaded_gifs_data.length > temp.max_preloaded_depot)
			{
				var remove_count = temp.preloaded_gifs_data.length -temp.max_preloaded_depot;
				for(var i in temp.preloaded_gifs_data)
				{
					temp.preloaded_gifs_data[i] = null;
					temp.preloaded_gifs_data.splice(i,1);
					if(i ==  remove_count)
					{
						break;
					}
				}
			}
	    }
	}
	temp.reset_preloads = function(){
		temp.preloaded_gifs = [];
		for(var i in temp.preloaded_gifs_data)
		{
			temp.preloaded_gifs_data[i] = null;
		}
		temp.preloaded_gifs_data = [];
	}
	
	 

	return temp;
});