angular.module('starter.controllers')

.controller('menuCtrl', function($scope, $rootScope, $state, $ionicSideMenuDelegate, $timeout, $ionicBackdrop, $ionicPopup, $filter, service_user,service_mcache, service_geo, _SERVER_SETTINGS){

	var user = service_user.getUser(), menu = {}, search_terms = service_mcache.get("_SEARCH_TERMS") || {};

    // menünün açılıp kapanmasını check ediyor
    $scope.$watch(function () {
         return $ionicSideMenuDelegate.getOpenRatio();
    },
    function (ratio) {
        if (ratio === 1){ // açıldı
            user = service_user.getUser();
            search_terms = service_mcache.get("_SEARCH_TERMS");
            
            menu.user = user;
            menu.get_search_terms();
        } else{
            // kapandı

            
             
        }
    });

   
    user.age = parseInt(user.age);
    menu.user = user;
    menu.cdn = _SERVER_SETTINGS.image_cdn_url;

    menu.search_terms = {};
     
    menu.get_search_terms = function(){
        user.age = parseInt(user.age);
        search_terms = service_mcache.get("_SEARCH_TERMS") || {};
       // console.warn("search_terms"+JSON.stringify(search_terms))
        if(search_terms.age_min)    search_terms.age_min = parseInt(search_terms.age_min) ;
        if(search_terms.age_max)    search_terms.age_max = parseInt(search_terms.age_max) ;
         
        menu.search_terms.gender1 =   typeof search_terms.gender1 != "undefined" ? search_terms.gender1  : user.gender == 1 ? false :  true;
        menu.search_terms.gender2 =   typeof search_terms.gender2 != "undefined" ? search_terms.gender2  : user.gender == 2 ? false : true;

        menu.search_terms.age_min = search_terms.age_min  ? search_terms.age_min : user.age - 10 >= 18 ? (user.age - 10) : 18;
        menu.search_terms.age_max = search_terms.age_max ? search_terms.age_max :  user.age + 10 <= 80 ? (user.age + 10) : 80;

        menu.search_terms.distance = search_terms.distance || 50;
 
       // console.warn("menu search_terms"+JSON.stringify(menu.search_terms))
        service_mcache.set("_SEARCH_TERMS",menu.search_terms);
    };
    menu.get_search_terms();

     
    menu.save_search_terms = function(){
        //if(angular.isDefined(menu.save_timeout)) $timeout.cancel(menu.save_timeout);
        //menu.save_timeout = $timeout(function(){
            service_mcache.set("_SEARCH_TERMS",menu.search_terms);
            if(menu.search_terms.gender1 == false && menu.search_terms.gender2 == false)
            {
                menu.search_terms.gender1 = true;
                menu.search_terms.gender2 = true;
            }
            //console.warn("menu.search_terms"+JSON.stringify(menu.search_terms))
            $rootScope.$broadcast("_REFRESH_SEARCH");

        //},50);
    };

    // user bilgilerini check ediyoruz, eksik bilgi varmı??
    

    

    $scope.$on("$ionicView.enter",function(){

        $timeout(function(){
            service_geo.is_available()
            .then(function(is_available){
                if(is_available)
                {
                    service_geo.get()
                }
                else
                {
                    var alertPopup = $ionicPopup.alert({
                        title: $filter('translate')('LocationNeeded'),
                        template: $filter('translate')('LocationNeededOpenSettings'),
                        okType:'button-calm'
                    });

                    alertPopup.then(function(res) {
                         service_geo.open_settings();
                    });
                }
            });
        },1000);

    });

    

    $scope.menu = menu;
});