angular.module('starter.controllers')

.controller('messagesCtrl', function($rootScope, $scope, $state, $window, $ionicHistory, $timeout, service_message,_SERVER_SETTINGS){

	 var messages = {};

    
     messages.cdn = _SERVER_SETTINGS.image_cdn_url;
     messages.conversation_list = [];
    messages.page = 1;
    messages.can_load_more = false;
    messages.limit = 10;
    messages.get_conversations = function(force)
    {
        if(force)
        {
            messages.conversation_list =[]; 
            messages.page = 1;
        }
        service_message.get_conversations(messages.page)
        .then(function(res){

             $scope.$broadcast('scroll.refreshComplete');
             $scope.$broadcast('scroll.infiniteScrollComplete');

            if(res.error == 0)
            {
                res.data.conversations.forEach(function(item){
                    messages.conversation_list.push(item);
                })

                if(res.data.conversations.length  == messages.limit)
                {
                    messages.can_load_more = true;
                }
                else
                {
                    messages.can_load_more = false;
                }
            }

        },function(){
             $scope.$broadcast('scroll.refreshComplete');
             $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }

    messages.load_more = function(){
        messages.page++;
        messages.get_conversations();
    }


     $scope.messages = messages;



    $scope.$on("$ionicView.enter",function(){
        $timeout(function(){
            if(messages.conversation_list.length == 0)
            messages.get_conversations(true);
        })
    });


      


        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
 
            viewData.enableBack = true;
        });
        $rootScope.$ionicGoBack = function() {
            $ionicHistory.goBack() || $state.go("app.search");
        };
});