angular.module('starter.controllers')
.controller('purchaseCtrl', function($rootScope, $scope, $state, $timeout, $window, $filter, $ionicPopup, $ionicLoading, $document, $ionicHistory, service_accounts, service_mcache, service_localstorage, service_user, service_api,  service_inapppurchase, service_review, _APP_SETTINGS){

	 
	 
	var purchase = {};   
	purchase.membership_type = service_user.get_membership();  
	purchase.is_premium = service_user.isPremium();
	console.warn("membership_type "+JSON.stringify(purchase.membership_type));
	purchase.all_products = [];
	purchase.first_product = {};
	purchase.second_product = {};
	purchase.onetime_product = {};
	purchase.buy = function(selected_product_id)
	{
		service_inapppurchase.subscribe(selected_product_id)
		.then(function(){
			//console.log("service_inapppurchase.subscribe");
			service_user.set_membership("pro");
			purchase.membership_type = service_user.get_membership();
			var alertPopup = $ionicPopup.alert({
			 title: $filter('translate')('PurhcaseSusccessfull'),
			 template: '<p class="text-center">'+$filter('translate')('PurchaseSuccessText')+'</p>'
		   });

		   alertPopup.then(function(res) {
				$window.location.reload(true);
		   });
			
		},function(err,mes){
			//console.warn("buy err"+JSON.stringify(err));
			//console.warn("buy err mes"+JSON.stringify(mes));
			//$window.location.reload(true);
		});
	}; 
	
	purchase.buy_onetime = function(selected_product_id)
	{
		service_inapppurchase.buy(selected_product_id)
		.then(function(){
			service_user.set_membership("pro");
			purchase.membership_type = service_user.get_membership();
			var alertPopup = $ionicPopup.alert({
			 title: $filter('translate')('PurhcaseSusccessfull'),
			 template: '<p class="text-center">'+$filter('translate')('PurchaseSuccessText')+'</p>'
		   });

		   alertPopup.then(function(res) {
				$window.location.reload(true);
		   });
			
		},function(){
			//$window.location.reload(true);
		});
	}; 
	
	 
	
	purchase.free = function()
	{
		
		service_review.ask(2)
		.then(function(){
			service_user.set_membership("free");
			purchase.membership_type = service_user.get_membership();  
				
				var alertPopup = $ionicPopup.alert({
				 title: $filter('translate')('FreeMembershipChoosen'),
				 template: '<p class="text-center">'+$filter('translate')('FreeMembershipChoosenText')+'</p>'
			   });

			   alertPopup.then(function(res) {
					$window.location.reload(true);
			   });
		});
	};
	
	purchase.onetime_buy_available = false;
	
	purchase.first_load_busy = false;
	purchase.first_load = function(){
		
		if(purchase.first_load_busy == true) return;
		purchase.first_load_busy = true;
		
		
	
		//service_user.set_membership("");
	 //service_mcache.remove("_APP_REVIEWED") ;
		service_inapppurchase.loadProducts()
		.then(function(prod){
			//console.warn("products "+JSON.stringify(prod));
			purchase.all_products = prod;
			for(var pindex in prod)
			{
				if(prod[pindex].productId == 'com.etech.whatstrack.haftalikabone')
				purchase.second_product = prod[pindex];
				else
				purchase.first_product = prod[pindex];
			}
			//purchase.first_product = prod[0];
			//purchase.second_product = prod[1];
			if(purchase.first_product.price)
			{
				var price = purchase.first_product.price.replace(/[^\d.\.,]/g,'').replace(",",'.');
				var currency = purchase.first_product.price.replace(/[\d.\.,]/g,'');
				//console.warn("price "+JSON.stringify(price));
				purchase.first_product.daily_price = Math.floor(price * 100 / 30)/100;
				purchase.first_product.currency = currency;
			}
			if(purchase.second_product.price)
			{
				var price = purchase.second_product.price.replace(/[^\d.\.,]/g,'').replace(",",'.');
				var currency = purchase.second_product.price.replace(/[\d.\.,]/g,'');
				//console.warn("price "+JSON.stringify(price));
				purchase.second_product.daily_price = Math.floor(price * 100 / 7)/100;
				purchase.second_product.currency = currency;
			}
			
			
				/* 13:58 5.08.2016*/
				service_inapppurchase.loadOnetimeProducts()
				.then(function(prod){
					
					purchase.onetime_product = prod[0];
					 
					if(purchase.onetime_product && purchase.onetime_product.price)
					{
						var price = purchase.onetime_product.price.replace(/[^\d.\.,]/g,'').replace(",",'.');
						var currency = purchase.onetime_product.price.replace(/[\d.\.,]/g,'');
						console.warn("onetime_product price "+JSON.stringify(price));
						purchase.onetime_product.daily_price = Math.floor(price * 100 / 30)/100;
						purchase.onetime_product.currency = currency;
						
						console.warn("loadOnetimeProducts "+JSON.stringify(prod));
					}
					 
					 $ionicLoading.hide();
					
				},function(err){
					//console.warn("loadOnetimeProducts err" +JSON.stringify(err));
				});
				
				/* ************************** */
				service_inapppurchase.can_buy_onetime()
				.then(function(res){
					if(res == 1)
					{
						//console.warn("1222222222222222222res"+JSON.stringify(res));
						purchase.onetime_buy_available = true;
						purchase.onetime_product_id = _APP_SETTINGS.in_app_purchase_onetime[0];
					}
					else
					{
						purchase.onetime_buy_available = false;
						purchase.onetime_product_id = '';
					}
					purchase.first_load_busy = false;
				},function(){
					purchase.first_load_busy = false;
				});
				/* ************************** */
			
			 $ionicLoading.hide();
			
		},function(){
			purchase.first_load_busy = false;
		});
		
		
	};
	
	
	$timeout(function(){
		
		purchase.first_load();
		
	},1000);
	
	$rootScope.$on("setupReload",function(){
		console.warn("!!!!!!!!!!!!!!!!!!!!!!!!!");
		purchase.first_load();
	});
	
	
	
	$scope.purchase = purchase; 
	   
	  
	
});