angular.module('starter.controllers')

.controller('searchCtrl', function($scope, $state, $stateParams, $window, $ionicBackdrop, $ionicPopup, $filter, $timeout, $ionicPlatform, $ionicLoading, $ionicSideMenuDelegate, $ionicHistory, $interval,
 service_user, service_geo, service_search, service_mcache, service_temp, _APP_SETTINGS, _SERVER_SETTINGS){

    
      
            
           //service_geo.is_available();

            var user = service_user.getUser();

            
             

            var search = {};

        $timeout(function(){

            var last_state = service_mcache.get('_SEARCH_PAGE_STATE')||{};
            search.cdn = _SERVER_SETTINGS.image_cdn_url;
            search.selected_tab = last_state.selected_tab ||  1; 
            search.show_bottom_menu = last_state.show_bottom_menu ||  0;
             
            
             // tab açıldığında otomatik yükler
            $ionicPlatform.ready(function(){
                $scope.$watch(function(){return search.selected_tab;},function(tab){
                    if(tab == 3)
                    {
                        search.agrees.get(true);
                    }
                    else if(tab == 2)
                    {
                        search.get_offer();
                    }
                    else if(tab == 1)
                    { 
                        if(search.list.length == 0 || search.list.length - search.current_user_index < 5)
                        {
                            search.search();
                        }
                    }
                });
            });

            $scope.$watch(function () {
                return $ionicSideMenuDelegate.getOpenRatio();
            },
            function (ratio) {
                if (ratio === 1){ // açıldı
                    
                } else{
                    // kapandı
                    if(search.refresh_search)
                    search.search(true);
                }
            });
        
            /* tab1 */ 
            
            search.refresh_search = false;
            $scope.$on("_REFRESH_SEARCH",function(){
                search.refresh_search = true;
            })


            search.current_user_index = last_state.current_user_index || 0;
            search.list_max_size = 15;
           
             
 
            // terms
            
            search.get_search_terms = function(){
                var search_terms = service_mcache.get("_SEARCH_TERMS") || {};
                var selected_gender = user.gender != 0 ? (user.gender == 1 ? 2 : 1) : 0;
                if(search_terms.age_min)
                {
                    
                    if(search_terms.gender1 == true && search_terms.gender2 == true)
                    {
                        selected_gender = 0;
                    }
                    else 
                    {   if(search_terms.gender1 == true)
                        {
                            selected_gender = 1;
                        }
                        if(search_terms.gender2 == true)
                        {
                            selected_gender = 2;
                        }
                        if(search_terms.gender1 == false && search_terms.gender2 == false)
                        {
                            selected_gender = 0;
                        }
                    }
                } 
                search.terms = {
                    gender: selected_gender,
                    age_min: search_terms.age_min || 18,
                    age_max: search_terms.age_max || 80,
                    distance: search_terms.distance || 50,
                    latitude: '',
                    longitude: '',
                    limit: 5
                };
                return search.terms; 
            }
            // /terms
            search.list = last_state.last_list || [];
            search.search = function(force){
                //search.missing_info();
                if(force){
                    search.list = [];
                    search.current_user_index = 0;
                    search.refresh_search = false;
                    search.get_search_terms();
                } 
                // console.warn("search.termssearch.terms"+JSON.stringify(search.terms))
                service_search.search(search.terms)
                .then(function(res){
                    if(res.error == 0)
                    {
                        var partners = res.data.results; 
                        partners.forEach(function(partner,ind){
                            search.list.push(partner);
                            service_temp.preload_gif(partner.user_image_id);
                        });
                        
                        // yani ilk sorguysa
                        if(search.list.length == partners.length)
                        {
                             if(search.list[search.current_user_index])
                             search.get_action_history(search.list[search.current_user_index].offer_id);
                        }

                        //sonuc yoksa
                        if(search.list.length == 0)
                        {
                            // sonuc kalmamış diğer menüyü aç
                            search.selected_tab = 2; 
                            search.show_bottom_menu = 1;
                        }
                        
                         
                       // console.warn("search.list res"+JSON.stringify(res))
                         
                    }
                    else
                    {
                        switch(res.message)
                        {
                            case 'access_token_is_invalid':
                           // kayıt işlemi tamamlanmamış, token bekleyip yeniden deniyoruz.
                            $timeout(function(){
                                search.search(true);
                            },1000);
                            break;
                            case 'location_needed':
                                service_geo.is_available()
                                .then(function(is_available){
                                    if(is_available)
                                    {
                                        $ionicLoading.show({delay:100});
                                        service_geo.get()
                                        .then(function(coords){
                                                 $ionicLoading.hide();
                                             $timeout(function(){
                                                search.search(true);
                                            },100);
                                        },function(){
                                            $ionicLoading.hide();
                                        });
                                    }
                                    else
                                    {
                                        var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('LocationCouldNotRetrieved'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                                        alertPopup.then(function(){
                                            service_geo.open_settings();
                                        });
                                    }
                                });
                            break;
                        }
                         
                        
                    }
                },function(){

                });
            };

            search.set_is_busy = false;
            search.set_user = function(new_index){ 
                if( search.set_is_busy == true) return;
                search.set_is_busy = true;
                if(new_index > search.current_user_index)
                search.effect_class = 'to_right';
                else
                search.effect_class = 'to_left';

                if(new_index > 4)
                {
                    search.list.splice(0,1);
                    search.current_user_index--;
                    new_index--;
                }
                if(search.list[new_index])
                {
                    search.get_action_history(search.list[new_index].offer_id);
                    $timeout(function(){
                        search.current_user_index =  new_index; 
                        
                    },300)
                    $timeout(function(){
                        search.effect_class = '';
                        search.set_is_busy = false;
                    },600);
                }
                else{
                    // sonuc kalmamış diğer menüyü aç
                    new_index = search.list.length -1 >= 0 ? search.list.length -1 : 0;
                    search.selected_tab = 2; 
                    search.show_bottom_menu = 1;
                    search.current_user_index =  new_index;
                }
                if(search.list.length - 5 < search.current_user_index)
                {
                    search.search();
                }
            };

            
            
            
             
            search.action_history = 0;
            search.get_action_history = function(offer_id){

                search.agrees_list = service_search.get_agreed_list();
                search.persuades_list = service_search.get_persuaded_list(); 

                var h = 0;
                
                if(search.agrees_list.indexOf(offer_id) > - 1)
                h = 1;
                if(search.persuades_list.indexOf(offer_id) > - 1)
                {
                    if(h == 1)
                    h = 3;
                    else
                    h = 2;
                }
                search.action_history = h;
                 
                return h;
            }

            search.add_agree = function(offer_id,is_persuade)
            {
				search.missing_info();
                service_search.add_agree(offer_id, is_persuade)
                .then(function(res){
                    if(res.error == 0)
                    {
                        // ok lendi, burada bi efekt şart 
                        if(is_persuade == 1)
                        {
                            service_search.push_persuade(offer_id);
                        }
                        else
                        {
                            service_search.push_agree(offer_id);
                        }
                       // search.set_user(search.current_user_index+1); 
                    }
                    else
                    {
                        var template = '';
                        switch(res.message)
                        {
                            default:
                            break;
                            case 'daily_agree_limit_reached':
                                template = $filter('translate')('daily_agree_limit_reached');
                            break;
                            case 'daily_persuade_limit_reached':
                                template = $filter('translate')('daily_persuade_limit_reached');
                            break;
                        }
                        if(template != '')
                        {
                            var alertPopup = $ionicPopup.alert({
                                title: $filter('translate')('Error'),
                                template: template,
                                okType: 'button-calm',
                                cssClass: 'text-center bigPopup'
                            });

                            alertPopup.then(function(res) {
                                $state.go("app.vip");
                            });
                        }
                    }
                },function(){

                })
                search.set_user(search.current_user_index+1); 
            };
            


            search.new_agreed_count = last_state.new_agreed_count ||  0;// !!!!!!!!! yeni agree aldıkça bu zımbırtı artacak, aktifken push ile tetikleyecez
            search.toggle_bottom_menu = function(){
                if(search.show_bottom_menu == 1)
                {
                    search.show_bottom_menu = 0;
                    search.selected_tab = 1; 
                }
                else
                {
                    search.show_bottom_menu = 1;
                    search.selected_tab = search.offer && search.offer.offer_id != null ? 3 : 2; 
                }
            };

            

            /* /tab1 */

            /* tab3 */

            search.agrees = {};

            search.agrees.page = 1;
            search.agrees.limit = 10;
            search.agrees.can_load_more = true;

            search.agrees.list = [];
            search.agrees.get = function(force){
                if(force) search.agrees.list = [];

                service_search.get_agrees(search.agrees.page)
                .then(function(res){
                   // console.log("AGRESSS RESS",JSON.stringify(res))
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    if(res.error == 0)
                    {
                        if(res.data.agrees.length < search.agrees.limit )
                        {
                            search.agrees.can_load_more = false;
                        }

                        res.data.agrees.forEach(function(item,index){
                            search.agrees.list.push(item);
                        });
                        
                        search.new_agreed_count = 0;
                    }
                    else
                    {

                    }

                },function(){
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
            };
            search.agrees.load_more = function(){
                if(search.agrees.can_load_more)
                {
                    search.agrees.page++;
                    search.agrees.get();
                }    
                // console.error("LİST SCROLL" );
            };

            search.agrees.onScroll = function(){
             //   console.error("LİST SCROLL" );
            };
           

            /* */

            /* ** tab2 *** */
            var offer_terms = service_mcache.get("_OFFER_TERMS") || {};
            search.offer = {
                prefered_gender: offer_terms.prefered_gender || 0 ,
                for_when: offer_terms.for_when || 1,
                repeated: offer_terms.repeated || true,
                want_to: offer_terms.want_to || '',
                offer_id: offer_terms.offer_id || null,
                
                want_to_guess: "",
                guess_list:[],
            };

            search.get_offer = function(){
                service_search.get_offer()
                .then(function(res){
                    if(res.error == 0)
                    {
                        if(res.data.offer && res.data.offer.offer_id)
                        {
                            search.offer.prefered_gender = parseInt(res.data.offer.prefered_gender);
                            search.offer.for_when = parseInt(res.data.offer.for_when);
                            search.offer.repeated = res.data.offer.repeated > 0 ? true : false;
                            search.offer.want_to = res.data.offer.want_to;
                            search.offer.latitude = res.data.offer.latitude;
                            search.offer.longitude = res.data.offer.longitude;
                            search.offer.offer_id = res.data.offer.offer_id;
                            
                            search.offer.want_to_guess = res.data.offer.want_to;

                            service_mcache.set("_OFFER_TERMS",search.offer);
                        }
                    }
                })
            };

            search.offer.save = function(){

                service_geo.is_available()
                .then(function(is_available){
                    if(is_available)
                    {
                        $ionicLoading.show({delay:100});
                        service_geo.get()
                        .then(function(coords){

                            if(search.offer.want_to.length > 3)
                            {
                                search.offer.latitude = coords.lat;
                                search.offer.longitude = coords.lng;

                                service_search.save_offer(search.offer)
                                .then(function(res){
                                     $ionicLoading.hide();
                                    if(res.error == 0)
                                    {
                                        search.offer.offer_id = res.data.offer_id;
                                        service_mcache.set("_OFFER_TERMS",search.offer);
                                        // başarılı kaydetti,
                                        var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Success'),
                                            template: $filter('translate')('OfferSavedSuccessfully'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                                        
                                        alertPopup.then(function(){
                                            search.selected_tab = 1; 
                                            search.show_bottom_menu = 0;

                                        });
                                        //ok

                                    }
                                    else
                                    {
                                        //hata tekrar dene
                                        var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('OfferNotSavedTryAgain'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                                    }
                                },function(err){
                                    // hata
                                     $ionicLoading.hide();
                                      var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('OfferNotSavedTryAgain'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                                });

                            }
                            else
                            {
                                // want_to çok kısa veya girmedi alert ver
                                 $ionicLoading.hide();
                                  var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('OfferTextTooShort'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                                        
                            }
                    
                        },function(){
                            // konum alınamadı hata
                            $ionicLoading.hide();
                            

                            var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('LocationCouldNotRetrieved'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                        })
                    }
                    else
                    {
                         $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('LocationCouldNotRetrieved'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });
                    }
                },function(){
                     $ionicLoading.hide();
                     var alertPopup = $ionicPopup.alert({
                                            title: $filter('translate')('Error'),
                                            template: $filter('translate')('LocationCouldNotRetrieved2'),
                                            okType:'button-calm',
                                            cssClass: 'text-center',
                                        });

                })
            }
            search.offer.promt_repeat = function(){
                // repeat i kapatırsa açmaya ikna et
                if(!search.offer.repeated)
                {
                    var confirmPopup = $ionicPopup.confirm({
                        title: $filter('translate')('WantToRepeat'),
                        cssClass: 'text-center',
                        cancelText: $filter('translate')('DontRepeat'),
                        okText: $filter('translate')('YesRepeat'),
                        okType: 'button-calm',
                        template: $filter('translate')('WantToRepeatText')
                    });

                    confirmPopup.then(function(res) {
                        if(res) {
                            search.offer.repeated = true;
                        } else {
                            search.offer.repeated = false;
                        }
                    });
                }
            }

            search.offer.check_length = function(){
               // console.log(search.offer.want_to.length);
               /* if(search.offer.want_to.length >= 60)
                {
                    search.offer.want_to = search.offer.want_to.substring(0,60);
                }*/
                
                service_search.guess_offer(search.offer.want_to_guess)
                .then(function(res){
                    if(res.error == 0)
                    {
                       search.offer.guess_list = res.data;
                       if(res.data.length == 0)
                       search.offer.want_to_guess = search.offer.want_to;

                    }
                },function(){

                });
            };
            
            search.offer.set_want_to = function(want_to)
            {
                console.log("want_to",want_to);
                search.offer.want_to = want_to;
                search.offer.want_to_guess = want_to;
                search.offer.guess_list = [];
            };

            /* ***** */ 



            


        });


        search.save_current_state = function(){
            
             service_mcache.set("_SEARCH_PAGE_STATE",
            {selected_tab: search.selected_tab, 
                show_bottom_menu: search.show_bottom_menu, 
                last_list: search.list, 
                new_agreed_count: search.new_agreed_count,
                current_user_index: search.current_user_index 
            });
        }
        
        $window.onPauseEvents.push(function(){
            search.save_current_state();
        })


        search.show_menu_tip = false;
        search.missing_info_is_active = false;
        search.missing_info = function(){
            if(search.missing_info_is_active == true) return;
            search.missing_info_is_active = true;
            $timeout(function(){
                if(user && ( parseInt(user.user_image_id) == 0 || user.name == '' || parseInt(user.age) <= 0 || parseInt(user.gender) <= 0) && $state.current.name != 'app.profile')
                {
                    search.show_menu_tip = false;
                    $timeout(function(){
                        $ionicBackdrop.retain();
                        var alertPopup = $ionicPopup.alert({
                            title: $filter('translate')('SomeInfosMissing'),
                            template: '<i class="ion-ios-help-empty repeated"></i>'+$filter('translate')('LetsFilloutSomeInfo'),
                            cssClass: 'bigPopup text-center',
                            okType: 'button-calm',
                            okText: $filter('translate')('TakeMeThere')
                        });

                        alertPopup.then(function(res) {
                            search.missing_info_is_active = false;    
                            $ionicBackdrop.release();
                            $state.go("app.profile");
                        });
                    });
                }
                else
                search.show_menu_tip = true;
            });
        };

        $scope.$on('$ionicView.enter', function (event, viewData) {
            
            //console.warn("viewData"+JSON.stringify(viewData))
             
             service_temp.reset_preloads();
        });
        
        search.is_keyboard_hidden = true;
        $scope.$on("native.keyboardshow", function(){
			search.is_keyboard_hidden = false;
			console.log("native.keyboardshow");
        });
        
         $scope.$on("native.keyboardhide", function(){
			search.is_keyboard_hidden = true;
			console.log("native.keyboardhide");
        });

        

        $scope.$on('$ionicView.beforeLeave',function(){
            search.save_current_state();
            service_temp.reset_preloads(); 
        });

        $scope.$on("onPushNotification",function(event,data){
            // !!! bildirim geldi, mesaj datasımı kontrol et!!! yeni mesajsa işlem yap, 
            if(data.additionalData && data.additionalData.data_message)
            {
                switch(data.additionalData.data_message.type )
                {
                    case 'new_offr':
                        $timeout(function(){
                            search.new_agreed_count = 1;  
                            if(data.additionalData.foreground === false)
                            {
                                
                                search.show_bottom_menu = 1;
                                search.selected_tab = 3;
                            }
                        },50);
                    break;
                    case 'add_offr':
                        $timeout(function(){
                         
                            if(data.additionalData.foreground === false)
                            { 
                                search.show_bottom_menu = 1;
                                search.selected_tab = 2;
                            }
                        },50);
                    break;
                }
            }
        });
         

        //console.warn("console.log($stateParams)"+JSON.stringify(console.log($stateParams)))
       $scope.search = search;
});