angular.module('starter.services')
.factory('service_review', function($q, service_mcache, $filter, $ionicPopup,  _APP_SETTINGS){
  
	var review = {};
	
	review.ask = function(content_type)
	{
		if(!content_type) content_type = 1;
		
		var template = (content_type == 1) ? 'StarItIfyouLikeContent' : 'StarItIfyouLikeContentFree';
		
		var defer = $q.defer();
	
			 //service_mcache.remove("_APP_REVIEWED") ;
			var already_done = service_mcache.get("_APP_REVIEWED") ;
			if(!already_done)
			{
				var myPopup = $ionicPopup.show({
					template: '<p class="text-center">'+ $filter('translate')(template).replace(/&gt;/g,'>').replace(/&lt;/g,'<') +'</p>',
					title: $filter('translate')('StarItIfyouLikeTitle') ,
					subTitle: $filter('translate')('StarItIfyouLikeSubTitle') ,
					buttons: [
					  { 
						text: $filter('translate')('Later'), 
						type: 'button-small',
						onTap: function(e) {
						
							
							service_mcache.set("_APP_REVIEWED",1,43200);
							defer.resolve();
						}
					  },
					  {
						text: '<b>'+$filter('translate')('ReViewAndStar')+'</b>',
						type: 'button-royal',
						onTap: function(e) {
							service_mcache.set("_APP_REVIEWED",1);
							
							var appId = _APP_SETTINGS.app_market_id;
	  
							LaunchReview.launch(appId, function(){
								 defer.resolve();
							});
							defer.resolve();
						}
					  }
					]
				  });  
			}
			else
			defer.resolve();
	
		return defer.promise;
	}; 

	review.redirect = function(app_id){
			var defer = $q.defer();
			LaunchReview.launch(app_id, function(){
								 defer.resolve();
							},function(){
									defer.reject();
							});
			return defer.promise;
	}
	

	return review;
});