angular.module('starter.services')
.factory('service_share', function($q, $window,$filter, _APP_SETTINGS){
  
	
    var share = {};

    share.share_pic = function(file){
        var defer = $q.defer();

        var options = {
            message: _APP_SETTINGS.share_app_url, 
            subject: '', 
            files: [file],
            url: file,
            chooserTitle: $filter('translate')('ChooseToShare')
        }
 

       $window.plugins.socialsharing.shareWithOptions(options,function(){

            defer.resolve();

        }, function(){
            defer.reject();
        });
        //$window.plugins.socialsharing.share(null, null, file, _APP_SETTINGS.share_app_url)

        return defer.promise;
    }

    share.share = function(){
        $window.plugins.socialsharing.share(null, null, null, _APP_SETTINGS.share_app_url);
    }
    
 

	return share;
});